/* $Id: e2_command.h 783 2005-05-20 13:10:04Z tpgww $
 * 
 * Copyright (C) 2004-2005 tooar <tooar@gmx.net>
 * 
 * This file is part of emelFM2.
 * emelFM2 is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * emelFM2 is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with emelFM2; see the file GPL. If not, contact the Free Software
 * Foundation, 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 */

#ifndef E2_COMMAND_H
#define E2_COMMAND_H

#include "emelfm2.h"
 
typedef enum
{
	E2_COMMAND_RANGE_DEFAULT,
	E2_COMMAND_RANGE_FILE_ACTION,
	E2_COMMAND_RANGE_FILE_OPERATION,
	E2_COMMAND_RANGE_SUBSHELL,
	E2_COMMAND_RANGE_CUSTOM
} E2_CommandRange;

typedef struct _E2_CommandRuntime
{
	gint pid;
	gchar *pidstr;
	gchar *command;
	gint exit;
	gboolean start;
	gboolean end;
	gboolean show;
	GIOChannel *ioin;
	gboolean closed;
} E2_CommandRuntime;

gboolean e2_command_find_process (gint pid);
gint e2_command_run (gchar *command, E2_CommandRange range);
void e2_command_list_children (gpointer data);
gboolean e2_command_kill_child (gint pid);
void e2_command_output_help (void);
void e2_command_actions_register (void);
void e2_command_options_register (void);

#endif //ndef E2_COMMAND_H
