/* $Id: e2_option_str.c 762 2005-05-13 04:00:38Z tpgww $
 * 
 * Copyright (C) 2004-2005 tooar <tooar@gmx.net>
 * 
 * This file is part of emelFM2.
 * emelFM2 is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * emelFM2 is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with emelFM2; see the file GPL. If not, contact the Free Software
 * Foundation, 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 */

#include "emelfm2.h"
#include <string.h>
#include "e2_option.h"
#include "e2_option_str.h"

E2_OptionSet *e2_option_str_register (gchar *name, gchar *group, gchar *desc,
	gchar *tip, gchar *depends, gchar *value, E2_OptionFlags flags)
{
	E2_OptionSet *set;
	if ((set = e2_option_get_simple (name)) != NULL)
		return set;
	set = g_malloc (sizeof (E2_OptionSet));
	//set up E2_OptionSet
	set->name = name;
	set->group = group;
	set->type = E2_OPTION_TYPE_STR;
	set->desc = desc;
	set->tip = tip;
	set->depends = depends;
	set->ival = -1;
	set->sval = g_strdup (value);
	set->flags = flags | E2_OPTION_FLAG_STR;
	e2_option_register (set);
	return set;
}

E2_OptionSet *e2_option_font_register (gchar *name, gchar *group, gchar *desc,
	gchar *tip, gchar *depends, gchar *def, E2_OptionFlags flags)
{
	E2_OptionSet *set = e2_option_str_register (name, group, desc, tip,
		depends, def, 0);
	set->type = E2_OPTION_TYPE_FONT;
	set->flags = flags | E2_OPTION_FLAG_FONT;
	return set;
}

gchar *e2_option_str_get (gchar *option)
{
	E2_OptionSet *set = e2_option_get (option);
	return set->sval;
}

gchar *_e2_option_str_get (E2_OptionSet *set)
{
	return set->sval;
}

void _e2_option_str_set (E2_OptionSet *set, gchar *value)
{
	g_free (set->sval);
	set->sval = g_strdup (value);
}
