/* $Id: e2_option_unknown.c 762 2005-05-13 04:00:38Z tpgww $
 * 
 * Copyright (C) 2004-2005 tooar <tooar@gmx.net>
 * 
 * This file is part of emelFM2.
 * emelFM2 is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * emelFM2 is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with emelFM2; see the file GPL. If not, contact the Free Software
 * Foundation, 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 */

#include "emelfm2.h"
#include "e2_option.h"
#include "e2_option_unknown.h"

#if 0
/**
 * @brief register an unkown option
 *
 * Register an as-yet unknown option to use the data later on. This function
 * is supposed to be used internally only.
 * Any already-existing unknown option with the same name will be removed first.
 *
 * @param option  string with the name of the option
 * @param value  option value (as a string), will be duplicated
 *
 * @return 
 **/
void e2_option_unknown_register (const gchar *option, const gchar *value)
{
	gchar *value_old;
	if ((value_old = g_hash_table_lookup (options_queue, option)) == NULL)
	{
		g_free (value_old);
		//FIXME = free's of non-constant strings
		g_hash_table_remove (options_queue, option);
	}
	g_hash_table_insert (options_queue, g_strdup (option), g_strdup (value));
}

/**
 * @brief register an unknown option
 *
 * Register an as-yet unknown option that is several lines long. This function
 * is currently only used for tree options. This function is supposed to be
 * used internally only. Any already-existing unknown option with the same name
 * will be removed first.
 * 
 * @param option  string with the name of the option
 * @param value  array of strings in config file format
 *
 * @return 
 **/
void e2_option_unknown_register2 (const gchar *option, gchar **value)
{
	gchar **value_old;
	if ((value_old = g_hash_table_lookup (options_queue, option)) == NULL)
	{
		g_strfreev (value_old);
		g_hash_table_remove (options_queue, option);
	}
	g_hash_table_insert (options_queue, g_strdup (option), value);
}
#endif //0
