/* $Id: e2_upgrade.c 762 2005-05-13 04:00:38Z tpgww $
 * 
 * Copyright (C) 2003-2005 tooar <tooar@gmx.net>
 *
 * This file is part of emelFM2.
 * emelFM2 is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * emelFM2 is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with emelFM2; see the file GPL. If not, contact the Free Software
 * Foundation, 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 */

#include "emelfm2.h"
#include <string.h>
#include "e2_upgrade.h"
#include "e2_option.h"
#include "e2_plugins.h"

#define PNAME "e2p_upgrade.so"

void e2_upgrade_check (void)
{
//	RUN_ONCE_CHECK ();  redundant
//	gchar *fn = g_build_filename (E2_CONFIG_DIR, 
//		default_config_file, NULL);
	if ( //! use e2_fs ... instead of g_file_test (fn, G_FILE_TEST_EXISTS) &&  test conducted before coming here
		! g_str_equal (cfg.version, VERSION) )
	{
		Plugin *p;
		gchar *ppath = g_strconcat (PLUGINS_DIR, PNAME, NULL);
		if ((p = e2_plugin_load (ppath)) != NULL)
		{
			if (!p->plugin_init (p))	//do it
				printd (ERROR, "can't initialize upgrade plugin: "PNAME);
			e2_plugins_unload1 (p);
		}
		else
			printd (ERROR, "can't find upgrade plugin "PNAME", so can't upgrade the config file");
		g_free (ppath);
	}
//	g_free (fn);
}

#undef PNAME
