/*
 *
 * Copyright (C) 2003-2005 tooar <tooar@gmx.net>
 * Portions copyright (C) 1999 Michael Clark.
 *
 * This file is part of emelFM2.
 * emelFM2 is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * emelFM2 is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with emelFM2; see the file GPL. If not, contact the Free Software
 * Foundation, 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 */

#include "emelfm2.h"
#include <string.h>
#include "e2_dialog.h"
#include "e2_task.h"
#include "e2_filetype.h"

//static gchar extension[NAME_MAX];

static void _e2_filetype_dialog_config_cb (GtkWidget *widget, GtkWidget *dialog)
{
	//kill the current dialog
	e2_dialog_cancel_cb (widget, dialog);
	//open the filetypes config dialog with no extension selected
	e2_filetype_config_show (NULL);
}

static void _e2_filetype_dialog_enter_command_cb (GtkWidget *widget, GtkWidget *dialog)
{
	e2_dialog_cancel_cb (widget, dialog);
	e2_task_open_with (NULL, NULL, NULL);
}

static void _e2_filetype_dialog_view_file_cb (GtkWidget *widget, GtkWidget *dialog)
{
	e2_dialog_cancel_cb (widget, dialog);
	e2_task_view (NULL, NULL, NULL);
}

void e2_filetype_dialog_create (FileInfo *info)
{
//	gchar *filename = g_strdup (info->filename);
	gchar *filename = info->filename;
	printd (DEBUG, "e2_filetype_dialog_create: %s", filename);
/*	gchar *ext;

	if (e2_fs_is_dir (info))
		ext =  _("<directory>");
	else if (e2_utils_is_executable (info))
		ext = _("<executable>");
	else
	{
		ext = strrchr (filename, '.');   //strrchr() has problem with eg tar.gz
		if (ext == NULL || *(ext+1) == '\0')
			ext = _I("<none>");
		else
			ext++;
	}
	g_strlcpy (extension, ext, sizeof (extension));
*/
	F_DECLARE;
	gchar *utf = F_FILENAME_FROM_LOCALE (filename);
	gchar *message = g_strdup_printf (_("What would you like to do with <b>%s</b> ?"), utf);
	F_FREE (utf);
	GtkWidget *dialog = e2_dialog_create (GTK_STOCK_DIALOG_QUESTION,
		message, _("unrecognised filetype"), NULL, NULL);
	g_free (message);

	e2_dialog_add_undefined_button_custom (dialog, FALSE, E2_RESPONSE_USER1,
		_("_Add.."), "gtk-preferences",
		_("Create a new filetype for this extension, or add it to an existing filetype"),
		_e2_filetype_dialog_config_cb, dialog);

	e2_dialog_add_undefined_button_custom (dialog, FALSE, E2_RESPONSE_USER2,
		_("_View"), ICON_DIR"view_"E2IP".png",
		_("Read the file's contents"),
		_e2_filetype_dialog_view_file_cb, dialog);

	GtkWidget *btn = e2_dialog_add_undefined_button_custom 
		(dialog, TRUE, E2_RESPONSE_USER3,
		_("_Open.."), ICON_DIR"open_with_"E2IP".png",
		_("Enter a command with which to open the file"),
		_e2_filetype_dialog_enter_command_cb, dialog);

	e2_dialog_add_button_custom (dialog, FALSE, &E2_BUTTON_CANCEL,
		NULL, e2_dialog_cancel_cb, dialog);

//	gtk_widget_set_sensitive (app.main_window, FALSE);
	e2_dialog_setup (dialog, app.main_window);
//	gtk_widget_show (dialog);
	_e2_dialog_show (dialog, NULL, 0);
	gtk_widget_grab_focus (btn);
}
