/*
 *
 * Copyright (C) 2003-2005 tooar <tooar@gmx.net>
 *
 * This file is part of emelFM2.
 * emelFM2 is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * emelFM2 is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with emelFM2; see the file GPL. If not, contact the Free Software
 * Foundation, 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 */

#include "emelfm2.h"
#include "e2_dialog.h"
#include "e2_task.h"

static gboolean _e2_open_dialog_enter_command_cb
	(GtkWidget *widget, GtkWidget *dialog)
{
  gtk_widget_set_sensitive (dialog, FALSE);
  e2_task_open_with (NULL, NULL, NULL);
  gtk_widget_destroy (dialog);
  return TRUE;
}

static gboolean _e2_open_dialog_view_file_cb
	(GtkWidget *widget, GtkWidget *dialog)
{
  e2_task_view (NULL, NULL, NULL);
  gtk_widget_set_sensitive (app.main_window, TRUE);
  gtk_widget_destroy (dialog);
  return TRUE;
}

void e2_open_dialog_create (gchar *filename)
{
  GtkWidget *dialog;
  GtkWidget *dialog_vbox;
  GtkWidget *action_area;
  GtkWidget *table;
  GtkWidget *wid;
  GString *message;

  dialog = gtk_dialog_new ();
  dialog_vbox = GTK_DIALOG (dialog)->vbox;
  action_area = GTK_DIALOG (dialog)->action_area;
  gtk_container_set_border_width (GTK_CONTAINER (dialog_vbox), E2_PADDING);
  gtk_container_set_border_width (GTK_CONTAINER (action_area), E2_PADDING);

  message = g_string_new (_("What would you like to do with this file?\n\n"));
  g_string_append_printf (message, "%s:  %s", _("Filename"), filename);
  wid = e2_widget_add_label (dialog_vbox, message->str, 0.5, FALSE, E2_PADDING_XSMALL);
  gtk_label_set_justify (GTK_LABEL (wid), GTK_JUSTIFY_LEFT);
  g_string_free (message, TRUE);

  table = add_table (action_area, 3, 1, TRUE, TRUE, E2_PADDING);
  gtk_table_set_row_spacings (GTK_TABLE (table), E2_PADDING);
  gtk_table_set_col_spacings (GTK_TABLE (table), E2_PADDING);

  add_button_to_table (table, _("_Enter a command to open with"),
	_e2_open_dialog_enter_command_cb, dialog, 0, 1, 0, 1);
  add_button_to_table (table, _("_View file"), 
	_e2_open_dialog_view_file_cb, dialog, 0, 1, 1, 2);
  add_button_to_table (table, _("_Cancel"), e2_dialog_cancel_cb, dialog, 0, 1, 2, 3);

  g_signal_connect (G_OBJECT (dialog), "key_press_event",
	G_CALLBACK (e2_dialog_key_press_cb), dialog);
  g_signal_connect (G_OBJECT (dialog), "delete_event",
	G_CALLBACK (e2_dialog_cancel_cb), dialog);

  gtk_widget_set_sensitive (app.main_window, FALSE);
  E2_DIALOG_TITLE (GTK_WINDOW (dialog), _("open query"));
  e2_dialog_setup (dialog, app.main_window);  
  gtk_widget_show (dialog);
}
