/* $Id: e2_search_dialog.h 762 2005-05-13 04:00:38Z tpgww $
 * 
 * Copyright (C) 2004-2005 tooar <tooar@gmx.net>
 * 
 * This file is part of emelFM2.
 * emelFM2 is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * emelFM2 is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with emelFM2; see the file GPL. If not, contact the Free Software
 * Foundation, 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 */

#ifndef E2_SEARCH_DIALOG_H
#define E2_SEARCH_DIALOG_H

#include "emelfm2.h"

typedef struct _E2_SearchDialogRuntime
{
	GtkWidget *dialog;
	GtkWidget *scrolled;
	GtkWidget *combo;
	GtkWidget *option_expander;
	GtkWidget *option_box;
	GtkWidget *info_expander;
	GtkWidget *info_box;
	GtkWidget *info_label;
	GtkWidget *textview;
	GtkTextBuffer *textbuffer;
	GtkWidget *parent;
	GList *history;
	gint history_cur;
	gboolean opt_show_last;
	gboolean opt_case_sensitive;
	gboolean opt_search_backward;
	gboolean opt_wrap;
} E2_SearchDialogRuntime;

GtkWidget *e2_search_dialog_create (GtkWidget *textview);
void e2_search_dialog_show (GtkWidget *textview, gchar *arg, GtkWidget *parent);
void e2_search_dialog_actions_register ();
void e2_search_dialog_options_register ();

#endif /* ifndef E2_SEARCH_DIALOG_H */
