/* $Id: e2_keybinding.h 957 2005-07-27 23:42:09Z tpgww $
 *
 * Copyright (C) 2004-2005 tooar <tooar@gmx.net>
 *
 * This file is part of emelfm2.
 * emelfm2 is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * emelfm2 is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with emelFM2; see the file GPL. If not, contact the Free Software
 * Foundation, 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 */

#ifndef E2_KEYBINDING_H
#define E2_KEYBINDING_H

#include "emelfm2.h"

typedef struct _E2_KeyRuntime
{
	GdkModifierType mask;
	guint keyval;
	gchar *action;
	gchar *action_data;
	gboolean cont;
	GList *chained;
} E2_KeyRuntime;

typedef struct _E2_KeybindingRuntime
{
	gchar *name;
	GtkTreeModel *model;
	GtkTreeRowReference *ref;
	gboolean synced;
	GList *keys;
	gint ref_count;
	GList *chained;
	guint timeout_id;
	GSList *instances;	//list of widgets to which this binding category has been applied
} E2_KeybindingRuntime;

GList *e2_keybinding_find_by_name (const gchar *name);
void e2_keybinding_register_all (void);
void e2_keybinding_register (const gchar *category, GtkWidget *widget);
void e2_keybinding_output_help (gchar *section);
void e2_keybinding_clean (void);
void e2_keybinding_options_register (void);

#endif //ndef E2_KEYBINDING_H
