/*
 *
 * Copyright (C) 2003-2005 tooar <tooar@gmx.net>
 *
 * This file is part of emelFM2.
 * emelFM2 is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * emelFM2 is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with emelFM2; see the file GPL. If not, contact the Free Software
 * Foundation, 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 */
 
#ifndef _E2_TASK_H
#define _E2_TASK_H

#include "emelfm2.h"
#include "e2_permissions_dialog.h"

// TEMP_FAILURE_RETRY for systems which do not have it
#ifndef TEMP_FAILURE_RETRY
#define TEMP_FAILURE_RETRY(expr) \
    ({ long int _res; \
       do _res = (long int) (expr); \
       while (_res == -1L && errno == EINTR); \
       _res; })
#endif

GList *open_history;  //history list for open-with dialog

gboolean e2_task_copy (gpointer action_data, gpointer rt_data, GtkWidget *widget);
gboolean e2_task_copy_as (gpointer action_data, gpointer rt_data, GtkWidget *widget);
gboolean e2_task_move (gpointer action_data, gpointer rt_data, GtkWidget *widget);
gboolean e2_task_move_as (gpointer action_data, gpointer rt_data, GtkWidget *widget);
gboolean e2_task_rename (gpointer action_data, gpointer rt_data, GtkWidget *widget);
gboolean e2_task_trashit (gpointer action_data, gpointer rt_data, GtkWidget *widget);
gboolean e2_task_delete (gpointer action_data, gpointer rt_data, GtkWidget *widget);
gboolean e2_task_symlink (gpointer action_data, gpointer rt_data, GtkWidget *widget);
gboolean e2_task_symlink_as (gpointer action_data, gpointer rt_data, GtkWidget *widget);
gboolean e2_task_permissions (gpointer action_data, gpointer rt_data, GtkWidget *widget);
gboolean e2_task_ownership (gpointer action_data, gpointer rt_data, GtkWidget *widget);
gboolean e2_task_file_info (gpointer action_data, gpointer rt_data, GtkWidget *widget);
gboolean e2_task_sync_dirs (gpointer action_data, gpointer rt_data, GtkWidget *widget);
gboolean e2_task_view (gpointer action_data, gpointer rt_data, GtkWidget *widget);
//gboolean __e2_task_toggle_tag (void);
gboolean e2_task_drop (gpointer func, gchar *uri_list, gchar *dest_dir);
gboolean e2_task_refresh (gpointer action_data, gpointer rt_data, GtkWidget *widget);
gboolean e2_task_command (gpointer action_data, gpointer rt_data, GtkWidget *widget);
gboolean e2_task_open (gpointer action_data, gpointer rt_data, GtkWidget *widget);
gboolean e2_task_open_with (gpointer action_data, gpointer rt_data, GtkWidget *widget);
gboolean e2_task_open_in_other_pane (gpointer action_data, gpointer rt_data, GtkWidget *widget);
gboolean e2_task_configure (GtkWidget *widget, gchar *page);
gboolean e2_task_configure_default (GtkWidget *widget);
gboolean e2_task_find (gpointer action_data, gpointer rt_data, GtkWidget *widget);

gboolean e2_task_backend_copy (gchar *src, gchar *dest);
gboolean e2_task_backend_move (gchar *src, gchar *dest);
gboolean e2_task_backend_link (gchar *target, gchar *name);
gboolean e2_task_backend_rename (gchar *oldsrc, gchar *newsrc);
gboolean e2_task_backend_delete (gchar *path);
gboolean e2_task_backend_chmod (gchar *path, gchar *mode,
	E2_RecurseType recurse);
gboolean e2_task_backend_chown (gchar *path, uid_t owner_id,
	gid_t group_id, gboolean recurse);
gboolean e2_task_backend_open (FileInfo *info);
gboolean e2_task_backend_view (gchar *filename);
void e2_task_actions_register (void);

#endif //ndef _E2_TASK_H
